/*
 * PizzaIngredientFactory.hpp
 *
 *  Created on: 3 нояб. 2021 г.
 *      Author: alexander
 */

#pragma once

#include "Dough.hpp"
#include "Sauce.hpp"
#include "Cheese.hpp"
#include "Veggies.hpp"
#include "Pepperoni.hpp"
#include "Clams.hpp"
#include <vector>

class PizzaIngredientFactory
{
public:
    virtual Dough* createDough() const = 0;
    virtual Sauce* createSauce() const = 0;
    virtual Cheese* createCheese() const = 0;
    virtual std::vector<Veggies*> createVeggies() const = 0;
    virtual Pepperoni* createPepperoni() const = 0;
    virtual Clams* createClam() const = 0;

    virtual ~PizzaIngredientFactory() {}
};
